export default class {
  constructor() {
    this.socket
    this.host
  }
  static connect(host) {
    this.host = host
    return new Promise((resolve, reject) => {
        let url = `ws://${host}`
        
        window.WebSocket = window.WebSocket || window.MozWebSocket;
        if(!window.WebSocket) {
          console.error('Error: WebSocket is not supported .')
          return;
        }

        this.socket = new WebSocket(url) // 创建连接并注册响应函数  
        this.socket.onopen = (event) => {
          if(this.socket.readyState == 1) {
            resolve(this.socket)
          } else{
            reject(event)
          }
        }
        this.socket.onerror = (error) => {
          this.connect(this.host)
          reject(error)
        }
        this.socket.onclose = (error) => {
          this.connect(this.host)
          reject(error)
        }
    })
  }
  close() {
    this.socket.close()
  }
}